package com.wordpress.salaboy.examples;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import junit.framework.Assert;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.base.MapGlobalResolver;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import bitronix.tm.TransactionManagerServices;
import bitronix.tm.resource.jdbc.PoolingDataSource;

import com.wordpress.salaboy.example.model.Person;

/**
 * This is a sample file to launch a process.
 */
public class HelloWorld {

	/**
	 * We are using JTA so we need a JTA-enabled DataSource
	 */
	private static PoolingDataSource ds1;

	/**
	 * Data source creation
	 */
	@BeforeClass
	public static void createDataSource() {
		ds1 = new PoolingDataSource();
		ds1.setUniqueName("jdbc/processInstanceDS");
		ds1.setClassName("com.mysql.jdbc.jdbc2.optional.MysqlXADataSource");
		ds1.setMaxPoolSize(3);
		ds1.setAllowLocalTransactions(true);
		// ds1.getDriverProperties().setProperty("driverClassName",
		// "com.mysql.jdbc.Driver");
		ds1.getDriverProperties().put("user", "root");
		ds1.getDriverProperties().put("password", "nagarro1136");
		ds1.getDriverProperties()
				.put("url",
						"jdbc:mysql://localhost/jbpmTest?user=root&password=nagarro1136");
		ds1.init();
	}

	/**
	 * Data source cleaning
	 */
	@AfterClass
	public static void closeDataSource() {
		if (ds1 != null) {
			ds1.close();
		}
	}

	@Test
	public void testHelloWorld() {
		try {
			// load up the knowledge base
			KnowledgeBase kbase = readKnowledgeBase();

//			EntityManagerFactory emf = Persistence
//					.createEntityManagerFactory("org.jbpm.task");
//			Environment env = KnowledgeBaseFactory.newEnvironment();
//			env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
//			env.set(EnvironmentName.TRANSACTION_MANAGER,
//					TransactionManagerServices.getTransactionManager());
//
//			env.set(EnvironmentName.GLOBALS, new MapGlobalResolver());
//
//			final StatefulKnowledgeSession ksession = JPAKnowledgeService
//					.newStatefulKnowledgeSession(kbase, null, env);
			
			final StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();

			KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory
					.newThreadedFileLogger(ksession, "test", 1000);
			// ksession.getWorkItemManager().registerWorkItemHandler("Human Task",
			// new WSHumanTaskHandler());
			// start a new process instance
			// Map<String, Object> params = new HashMap<String, Object>();
			// params.put("employee", "krisv");
			// params.put("reason", "Yearly performance evaluation");
			Person person = new Person();
			person.setName("Abhishek Chavan");
			
			Map<String, Object> paramaMap = new HashMap<String, Object>();

			Thread t = new Thread(new Runnable() {
				
				@Override
				public void run() {
					ksession.fireUntilHalt();
				}
			});
			
			t.setDaemon(true);
			t.start();
			
			paramaMap.put("employee", person);
			ProcessInstance processInstance = ksession.startProcess(
					"HelloWorld", paramaMap);
			
			
			while(processInstance.getState() != ProcessInstance.STATE_COMPLETED){
				Thread.sleep(1);
				System.out.println("Yes!!");
			}

			Assert.assertTrue(processInstance.getState() == ProcessInstance.STATE_COMPLETED);
			Assert.assertEquals(person.getRollNo(), 30);
			logger.close();
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory
				.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("HelloWorld.bpmn2"),
				ResourceType.BPMN2);
		kbuilder.add(ResourceFactory.newClassPathResource("helloWorld.drl"),
				ResourceType.DRL);
		return kbuilder.newKnowledgeBase();
	}

}
